require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_H_)) {
    eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
    if(defined(&_KERNEL)  && !defined(&_LOCORE)) {
	if(defined(&MULTIPROCESSOR)) {
	    eval 'sub LOCK () {"lock";}' unless defined(&LOCK);
	} else {
	    eval 'sub LOCK () {1;}' unless defined(&LOCK);
	}
	eval 'sub i386_atomic_testset_uq {
	    my($ptr,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&i386_atomic_testset_uq);
	eval 'sub i386_atomic_testset_ul {
	    my($ptr,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&i386_atomic_testset_ul);
	eval 'sub i386_atomic_testset_i {
	    my($ptr,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&i386_atomic_testset_i);
	eval 'sub i386_atomic_setbits_l {
	    my($ptr,$bits) = @_;
    	    eval q({  &__asm  &volatile( &LOCK \\" orl %1,%0\\" : \\"=m\\" (*$ptr) : \\"ir\\" ($bits)); });
	}' unless defined(&i386_atomic_setbits_l);
	eval 'sub i386_atomic_clearbits_l {
	    my($ptr,$bits) = @_;
    	    eval q({ $bits = ~$bits;  &__asm  &volatile( &LOCK \\" andl %1,%0\\" : \\"=m\\" (*$ptr) : \\"ir\\" ($bits)); });
	}' unless defined(&i386_atomic_clearbits_l);
	eval 'sub i386_atomic_cas_int32 {
	    my($ptr,$expect,$set) = @_;
    	    eval q({ \'int\'  &res;  &__asm  &volatile( &LOCK \\" cmpxchgl %2, %1\\" : \\"=a\\" ( &res), \\"=m\\" (*$ptr) : \\"r\\" ($set), \\"a\\" ($expect), \\"m\\" (*$ptr) : \\"memory\\"); ( &res); });
	}' unless defined(&i386_atomic_cas_int32);
	eval 'sub __membar {
	    my($_f) = @_;
    	    eval q( &do {  &__asm  &__volatile($_f ::: \\"memory\\"); }  &while (0));
	}' unless defined(&__membar);
	if(defined(&MULTIPROCESSOR)) {
	    eval 'sub membar_enter () {
	        eval q( &__membar(\\"lock; addl $0,0(%%esp)\\"));
	    }' unless defined(&membar_enter);
	    eval 'sub membar_exit () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_exit);
	    eval 'sub membar_producer () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_producer);
	    eval 'sub membar_consumer () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_consumer);
	    eval 'sub membar_sync () {
	        eval q( &__membar(\\"lock; addl $0,0(%%esp)\\"));
	    }' unless defined(&membar_sync);
	} else {
	    eval 'sub membar_enter () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_enter);
	    eval 'sub membar_exit () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_exit);
	    eval 'sub membar_producer () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_producer);
	    eval 'sub membar_consumer () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_consumer);
	    eval 'sub membar_sync () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_sync);
	}
	eval 'sub virtio_membar_producer () {
	    eval q( &__membar(\\"\\"));
	}' unless defined(&virtio_membar_producer);
	eval 'sub virtio_membar_consumer () {
	    eval q( &__membar(\\"\\"));
	}' unless defined(&virtio_membar_consumer);
	eval 'sub virtio_membar_sync () {
	    eval q( &__membar(\\"lock; addl $0,0(%%esp)\\"));
	}' unless defined(&virtio_membar_sync);
	eval 'sub futex_atomic_ucas_int32 () { &ucas_32;}' unless defined(&futex_atomic_ucas_int32);
	eval 'sub atomic_setbits_int () { &i386_atomic_setbits_l;}' unless defined(&atomic_setbits_int);
	eval 'sub atomic_clearbits_int () { &i386_atomic_clearbits_l;}' unless defined(&atomic_clearbits_int);
	undef(&LOCK) if defined(&LOCK);
    }
}
1;
